<script setup lang="ts">
  import { Popover, PopoverButton, PopoverPanel, TransitionRoot } from '@headlessui/vue';
  import { emitsKey, propsKey } from './model';
  import { NavigationItem } from '~/logic/interfaces';

  const props = inject(propsKey);
  const emits = inject(emitsKey);

  const slideGroupList = computed(() => {
    return props?.navigationController?.slideGroupList ?? [];
  });

  const currentSlideIndex = computed(() => {
    return props?.navigationController?.currentSlideIndex ?? 0;
  });

  const handleSlideSelected = (close: () => void, item: NavigationItem) => {
    close();
    emits?.onChange('navigateToSlide', item.index);
  };
</script>

<template>
  <Popover v-slot="{ open }" class="relative">
    <PopoverButton as="div">
      <SwTooltip :content="$t('slides')" position="topCenter" width="max-width" :disabled="open">
        <SwButton fab :variant="open ? 'primary' : 'action'">
          <template #icon>
            <span class="i-sw-solid:bars"></span>
          </template>
        </SwButton>
      </SwTooltip>
    </PopoverButton>

    <TransitionRoot
      appear
      as="template"
      :show="open"
      enter="transition duration-200 ease-out"
      enter-from="opacity-0"
      enter-to="opacity-100"
      leave="transition duration-150 ease-in"
      leave-from="opacity-100"
      leave-to="opacity-0"
    >
      <PopoverPanel
        v-slot="{ close }"
        class="rounded-2 shadow-5 z-toolbar absolute bottom-16 w-80 overflow-hidden bg-white"
      >
        <div
          class="border-border bg-background-raised flex items-center justify-between border-b p-4"
        >
          <p class="font-bold tracking-[0.16px]">{{ $t('navigation') }}</p>
          <button @click="close">
            <span class="i-sw-regular:times-xs" />
          </button>
        </div>

        <div class="max-h-96 overflow-y-scroll px-2 py-1">
          <div v-for="group of slideGroupList" :key="group.id">
            <div v-if="group.items.every((item) => !item.isInstantListing)" class="mb-0.5">
              <p
                class="rounded-2 font-600 bg-background-elevated w-full px-2 py-1 text-left text-xs"
              >
                {{ group.name }}
              </p>
            </div>

            <div v-if="group.items.length" class="flex flex-col">
              <button
                v-for="item of group.items"
                :key="item.sectionId"
                class="rounded-2 hover:bg-interactive-pressed mb-0.5 flex w-full items-center justify-between px-2"
                :class="{ '!bg-primary': item.index === currentSlideIndex }"
                @click="handleSlideSelected(close, item)"
              >
                <div class="flex w-full items-center">
                  <span
                    v-if="item.isInstantListing"
                    class="i-sw-solid:list text-(base information-disabled) mr-1.5"
                  />

                  <p
                    class="text-(information left sm) min-w-0 flex-1 truncate py-1.5 font-medium"
                    :class="{ '!text-white': item.index === currentSlideIndex }"
                  >
                    {{
                      (item.isInstantListing ? item.groupName : item.sectionName) ||
                      `${$t('presentation.slide')} ${item.index}`
                    }}
                  </p>
                  <span
                    v-if="item.index === currentSlideIndex"
                    class="i-sw-regular:checkmark-xs text-white"
                  />
                </div>
              </button>
            </div>
          </div>
        </div>
      </PopoverPanel>
    </TransitionRoot>
  </Popover>
</template>
